/*
 * generated by Xtext
 */
package com.mncml.dsl.serializer;

import com.google.inject.Inject;
import com.mncml.dsl.services.MncGrammarAccess;
import java.util.List;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.IGrammarAccess;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.nodemodel.INode;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.AbstractElementAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.AlternativeAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.TokenAlias;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynNavigable;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynTransition;
import org.eclipse.xtext.serializer.sequencer.AbstractSyntacticSequencer;

@SuppressWarnings("all")
public abstract class AbstractMncSyntacticSequencer extends AbstractSyntacticSequencer {

	protected MncGrammarAccess grammarAccess;
	protected AbstractElementAlias match_ArrayType_CommaKeyword_5_3_0_q;
	protected AbstractElementAlias match_ResponsibleItemList_ANDKeyword_1_0_3_0_1_or_ORKeyword_1_0_3_0_0;
	protected AbstractElementAlias match_ResponsibleItemList_ANDKeyword_1_1_3_0_1_or_ORKeyword_1_1_3_0_0;
	protected AbstractElementAlias match_ResponsibleItemList_ANDKeyword_1_2_3_0_1_or_ORKeyword_1_2_3_0_0;
	protected AbstractElementAlias match_ResponsibleItemList_ANDKeyword_1_3_3_0_1_or_ORKeyword_1_3_3_0_0;
	
	@Inject
	protected void init(IGrammarAccess access) {
		grammarAccess = (MncGrammarAccess) access;
		match_ArrayType_CommaKeyword_5_3_0_q = new TokenAlias(false, true, grammarAccess.getArrayTypeAccess().getCommaKeyword_5_3_0());
		match_ResponsibleItemList_ANDKeyword_1_0_3_0_1_or_ORKeyword_1_0_3_0_0 = new AlternativeAlias(false, false, new TokenAlias(false, false, grammarAccess.getResponsibleItemListAccess().getANDKeyword_1_0_3_0_1()), new TokenAlias(false, false, grammarAccess.getResponsibleItemListAccess().getORKeyword_1_0_3_0_0()));
		match_ResponsibleItemList_ANDKeyword_1_1_3_0_1_or_ORKeyword_1_1_3_0_0 = new AlternativeAlias(false, false, new TokenAlias(false, false, grammarAccess.getResponsibleItemListAccess().getANDKeyword_1_1_3_0_1()), new TokenAlias(false, false, grammarAccess.getResponsibleItemListAccess().getORKeyword_1_1_3_0_0()));
		match_ResponsibleItemList_ANDKeyword_1_2_3_0_1_or_ORKeyword_1_2_3_0_0 = new AlternativeAlias(false, false, new TokenAlias(false, false, grammarAccess.getResponsibleItemListAccess().getANDKeyword_1_2_3_0_1()), new TokenAlias(false, false, grammarAccess.getResponsibleItemListAccess().getORKeyword_1_2_3_0_0()));
		match_ResponsibleItemList_ANDKeyword_1_3_3_0_1_or_ORKeyword_1_3_3_0_0 = new AlternativeAlias(false, false, new TokenAlias(false, false, grammarAccess.getResponsibleItemListAccess().getANDKeyword_1_3_3_0_1()), new TokenAlias(false, false, grammarAccess.getResponsibleItemListAccess().getORKeyword_1_3_3_0_0()));
	}
	
	@Override
	protected String getUnassignedRuleCallToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if(ruleCall.getRule() == grammarAccess.getEBooleanRule())
			return getEBooleanToken(semanticObject, ruleCall, node);
		return "";
	}
	
	/**
	 * EBoolean returns ecore::EBoolean:
	 * 	'true' | 'false';
	 */
	protected String getEBooleanToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		if (node != null)
			return getTokenText(node);
		return "true";
	}
	
	@Override
	protected void emitUnassignedTokens(EObject semanticObject, ISynTransition transition, INode fromNode, INode toNode) {
		if (transition.getAmbiguousSyntaxes().isEmpty()) return;
		List<INode> transitionNodes = collectNodes(fromNode, toNode);
		for (AbstractElementAlias syntax : transition.getAmbiguousSyntaxes()) {
			List<INode> syntaxNodes = getNodesFor(transitionNodes, syntax);
			if(match_ArrayType_CommaKeyword_5_3_0_q.equals(syntax))
				emit_ArrayType_CommaKeyword_5_3_0_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_ResponsibleItemList_ANDKeyword_1_0_3_0_1_or_ORKeyword_1_0_3_0_0.equals(syntax))
				emit_ResponsibleItemList_ANDKeyword_1_0_3_0_1_or_ORKeyword_1_0_3_0_0(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_ResponsibleItemList_ANDKeyword_1_1_3_0_1_or_ORKeyword_1_1_3_0_0.equals(syntax))
				emit_ResponsibleItemList_ANDKeyword_1_1_3_0_1_or_ORKeyword_1_1_3_0_0(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_ResponsibleItemList_ANDKeyword_1_2_3_0_1_or_ORKeyword_1_2_3_0_0.equals(syntax))
				emit_ResponsibleItemList_ANDKeyword_1_2_3_0_1_or_ORKeyword_1_2_3_0_0(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_ResponsibleItemList_ANDKeyword_1_3_3_0_1_or_ORKeyword_1_3_3_0_0.equals(syntax))
				emit_ResponsibleItemList_ANDKeyword_1_3_3_0_1_or_ORKeyword_1_3_3_0_0(semanticObject, getLastNavigableState(), syntaxNodes);
			else acceptNodes(getLastNavigableState(), syntaxNodes);
		}
	}

	/**
	 * Ambiguous syntax:
	 *     ','?
	 *
	 * This ambiguous syntax occurs at:
	 *     values+=PrimitiveValue (ambiguity) ')' (rule end)
	 */
	protected void emit_ArrayType_CommaKeyword_5_3_0_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     'OR' | 'AND'
	 *
	 * This ambiguous syntax occurs at:
	 *     responsibleCommands+=[Command|QualifiedName] (ambiguity) responsibleCommands+=[Command|QualifiedName]
	 */
	protected void emit_ResponsibleItemList_ANDKeyword_1_0_3_0_1_or_ORKeyword_1_0_3_0_0(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     'OR' | 'AND'
	 *
	 * This ambiguous syntax occurs at:
	 *     responsibleEvents+=[Event|QualifiedName] (ambiguity) responsibleEvents+=[Event|QualifiedName]
	 */
	protected void emit_ResponsibleItemList_ANDKeyword_1_1_3_0_1_or_ORKeyword_1_1_3_0_0(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     'OR' | 'AND'
	 *
	 * This ambiguous syntax occurs at:
	 *     responsibleAlarms+=[Alarm|QualifiedName] (ambiguity) responsibleAlarms+=[Alarm|QualifiedName]
	 */
	protected void emit_ResponsibleItemList_ANDKeyword_1_2_3_0_1_or_ORKeyword_1_2_3_0_0(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Ambiguous syntax:
	 *     'OR' | 'AND'
	 *
	 * This ambiguous syntax occurs at:
	 *     responsibleDataPoints+=[DataPoint|QualifiedName] (ambiguity) responsibleDataPoints+=[DataPoint|QualifiedName]
	 */
	protected void emit_ResponsibleItemList_ANDKeyword_1_3_3_0_1_or_ORKeyword_1_3_3_0_0(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
}
